var CrLf = "\r\n";

function ConverterOptions() {
  this._pathToRoot = "";
  this._buttonsToImages = false;
  this._languageId = "";
}

ConverterOptions.prototype = {

  setConvertButtonsToImages : function (value) {
    this._buttonsToImages = value;
  },

  getConvertButtonsToImages : function () {
    return this._buttonsToImages;
  },

  setPathToRoot : function (value) {
    this._pathToRoot = value;
  },

  getPathToRoot : function () {
    return this._pathToRoot;
  },

  setLanguageId : function (value) {
    this._languageId = value;
  },

  getLanguageId : function () {
    return this._languageId;
  }

};

/**
  <function name="convertRecord"/>
 */
function convertRecord(content, options) {
  // 1.1
  
  var beforeReplacingHeader = content;

  var chapter01_01rp = '<form$1>' + CrLf
    + '<table cellspacing="0" cellpadding="0" border="0">' + CrLf
    + '<tr><td valign="top">' + CrLf
    + '  <table cellspacing="0" cellpadding="0" border="0" class="Header">' + CrLf
    + '    <tr>' + CrLf
    + '      <td class="HeaderLeft"><img border="0" src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/Spacer.gif"></td>' + CrLf
    + '      <th>$2</th>' + CrLf
    + '      <td class="HeaderRight"><img border="0" src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/Spacer.gif"></td>' + CrLf
    + '    </tr>' + CrLf
    + '  </table>' + CrLf
    + '  <table class="Record" cellspacing="0" cellpadding="0">' + CrLf;

  content = content.replace(new RegExp(
    '<form([^>]*)>\\s*<font[^>]+class="[^"]*FormHeaderFont"[^>]*>([^<]+)</font>\\s*'
      + '(<br>\\s*&nbsp;)?'
      + '\\s*<table[^>]+class="[^"]*FormTABLE"[^>]*>', 'gi'), 
    chapter01_01rp);

  content = content.replace(new RegExp(
    '<form([^>]*)>()()\\s*<table[^>]+class="[^"]*FormTABLE"[^>]*>', 'gi'),
    chapter01_01rp);

  var headerReplaced = (beforeReplacingHeader != content);

  // 1.2
  content = content.replace(new RegExp(
    '<!--\\s+BEGIN\\s+Error\\s+-->\\s*<tr([^>]*)>', 'gi'), 
    '<!-- BEGIN Error -->' + CrLf + '<tr class="Error"$1>');

  // 1.3
  content = content.replace(new RegExp(
    '<tr([^>]*)>\\s*<td([^>]+)class="([^"]+)FooterTD"([^>]*)>', 'gi'), 
    '<tr class="Bottom"$1>' + CrLf + '  <td$2class="$3FooterTD"$4>');

  // 1.4
  content = content.replace(new RegExp(
    '<tr([^>]*)>\\s*<td([^>]+)class="([^"]+)FieldCaptionTD"([^>]*)>', 'gi'), 
    '<tr class="Controls"$1>' + CrLf + '  <td$2class="$3FieldCaptionTD"$4>');

  content = content.replace(new RegExp(
    '<td([^>]+)class="([^"]+)FieldCaptionTD"([^>]*)>([^<]*)</td>', 'gi'), 
    '<th$1class="$2FieldCaptionTD"$3>$4</th>');

  // 1.5
  if (options.getConvertButtonsToImages()) {
    content = content.replace(new RegExp(
      '<!--\\s+BEGIN\\s+Button\\s+([^>]*)?(Search|Insert|Update|Delete|Cancel|Login)(1)?\\s+-->'
        + '\\s*<input([^>]+)type="submit"([^>]*)>\\s*'
        + '<!--\\s+END\\s+Button\\s+([^>]*)?(Search|Insert|Update|Delete|Cancel|Login)(1)?\\s+-->', 'gi'),
      '<!-- BEGIN Button $1$2$3 -->'
       + '<input$4type="image" border="0" src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/'
       + options.getLanguageId() + '/Button$2.gif"$5>'
       + '<!-- END Button $1$2$3 -->');
  }

  // 1.6
  content = content.replace(new RegExp(
    'src="Themes/DatePicker/DatePicker1.gif"', 'gi'), 
    'src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/DatePicker.gif"');

  // 1.7
  if (headerReplaced) {
    content = content.replace(new RegExp(
      '</form>', 'gi'), 
      '</td></tr></table></form>');
  }

  return content;
}


/**
  <function name="convertEditableGrid"/>
 */
function convertEditableGrid(content, options) {
  return convertGrids('EditableGrid', content, options);
}

/**
  <function name="convertGrid"/>
 */
function convertGrid(content, options) {
  return convertGrids('Grid', content, options);
}

/**
  <function name="convertGrids"/>
 */
function convertGrids(type, content, options) {

  var columnsMatches = new RegExp('colspan="([^"]*)"', 'i').exec(content);
  var columns = (null != columnsMatches) ? columnsMatches[1] : 1;

  var beforeReplacingHeader = content;

  // 2.1
  var chapter02_01rp = '$1' + CrLf
    + '<table cellspacing="0" cellpadding="0" border="0">' + CrLf
    + '<tr><td valign="top">' + CrLf
    + '  <table cellspacing="0" cellpadding="0" border="0" class="Header">' + CrLf
    + '    <tr>' + CrLf
    + '      <td class="HeaderLeft"><img border="0" src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/Spacer.gif"></td>' + CrLf
    + '      <th>$2</th>' + CrLf
    + '      <td class="HeaderRight"><img border="0" src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/Spacer.gif"></td>' + CrLf
    + '    </tr>' + CrLf
    + '  </table>' + CrLf
    + '  <table class="Grid" cellspacing="0" cellpadding="0">' + CrLf;


  content = content.replace(new RegExp(
    '(<form[^>]*>)?\\s*<font[^>]+class="[^"]*FormHeaderFont"[^>]*>([^<]+)</font>\\s*'
      + '(<br>\\s*&nbsp;\\s*)?'
      + '<table[^>]+class="[^"]*FormTABLE"[^>]*>', 'gi'), 
    chapter02_01rp);

  content = content.replace(new RegExp(
    '(<form[^>]*>)?()\\s*<table[^>]+class="[^"]*FormTABLE"[^>]*>', 'gi'), 
    chapter02_01rp);

  var headerReplaced = (beforeReplacingHeader != content);

  // 2.2
  if ("EditableGrid" == type) {
    content = content.replace(new RegExp(
      '<!--\\s+END\\s+RowError\\s+-->\\s*<tr([^>]*)>', 'gi'), 
      '<!-- END RowError -->' + CrLf + '<tr class="Row"$1>');
  } else {
    content = content.replace(new RegExp(
      '<!--\\s+BEGIN\\s+Row\\s+-->\\s*<tr([^>]*)>', 'gi'), 
      '<!-- BEGIN Row -->' + CrLf + '<tr class="Row"$1>');
  }

  // 2.3, 2.4, 2.5
  content = content.replace(new RegExp(
    '<!--\\s+BEGIN\\s+(AltRow|NoRecords|Separator)\\s+-->\\s*<tr([^>]*)>', 'gi'), 
    '<!-- BEGIN $1 -->' + CrLf + '<tr class="$1"$2>');

  // 2.6
  content = content.replace(new RegExp(
    '<tr([^>]*)>\\s*<td([^>]+)class="([^"]+)ColumnTD"([^>]*)>', 'gi'), 
    '<tr class="Caption"$1>' + CrLf + '  <td$2class="$3ColumnTD"$4>');

  // 2.7
  content = content.replace(new RegExp(
    '<td([^>]+)class="([^"]+)ColumnTD"([^>]*)>([^<]*)</td>', 'gi'), 
    '<th$1$3>$4</th>');

  // 2.8
  content = content.replace(new RegExp(
    '<tr>\\s*<td([^>]*)class="[^"]+FooterTD"[^>]*>', 'gi'),
    '<tr$1 class="Footer">' + CrLf + '  <td colspan="' + columns + '">');

  // 2.13
  content = content.replace(new RegExp(
    'src="[^"]*Themes/DatePicker/DatePicker1.gif"', 'gi'), 
    'src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/DatePicker.gif"');

  // 2.9
  content = content.replace(new RegExp(
    'src="([^"]*)Themes/[^/]+/', 'gi'), 
    'src="$1Styles/{CCS_Style}/Images/');

  // 2.10, 2.11
  content = content.replace(new RegExp(
    '(Asc|Desc|First|Last|Prev|Next)On.gif', 'gi'), 
    '$1.gif');

  // 2.12
  var chapter03_12re = new RegExp('Total\\s+Records:&nbsp;\\s*{([^}]+)_TotalRecords}&nbsp;');
  var chapter03_12result = chapter03_12re.exec(content);
  if (null != chapter03_12result) {
    content = content.replace(chapter03_12re, "");
    var chapter03_12_2re = new RegExp('<table\\s+class="Grid"\\s+cellspacing="0"\\s+cellpadding="0">', 'gi');
    var chapter03_12_2rp = '<table class="Grid" cellspacing="0" cellpadding="0">' + CrLf
      + '  <tr class="Row">' + CrLf
      + '    <td colspan="' + columns + '">Total Records:&nbsp; {' + chapter03_12result[1] + '_TotalRecords}&nbsp;</td>' + CrLf
      + '  </tr>';
    content = content.replace(chapter03_12_2re, chapter03_12_2rp);
  }

  // 2.14
  if (options.getConvertButtonsToImages()) {
    content = content.replace(new RegExp(
      '<!--\\s+BEGIN\\s+Button\\s+(Button_)?Submit(1)?\\s+-->'
        + '\\s*<input([^>]+)type="submit"([^>]*)>\\s*'
        + '<!--\\s+END\\s+Button\\s+(Button_)?Submit(1)?\\s+-->', 'gi'), 
      '<!-- BEGIN Button $1Submit$2 -->'
        + '<input$3type="image" border="0" src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/'
        + options.getLanguageId() + '/ButtonUpdate.gif"$4>'
        + '<!-- END Button $1Submit$2 -->');

    content = content.replace(new RegExp(
      '<!--\\s+BEGIN\\s+Button\\s+(Button_)?Cancel(1)?\\s+-->'
        + '\\s*<input([^>]+)type="submit"([^>]*)>\\s*'
        + '<!--\\s+END\\s+Button\\s+(Button_)?Cancel(1)?\\s+-->', 'gi'), 
      '<!-- BEGIN Button $1Cancel$2 -->'
        + '<input$3type="image" border="0" src="' + options.getPathToRoot() + 'Styles/{CCS_Style}/Images/'
        + options.getLanguageId() + '/ButtonCancel.gif"$4>'
        + '<!-- END Button $1Cancel$2 -->');
  }

  // 2.16, 2.17
    if (headerReplaced) {
      content += "</td></tr></table>";
    }

  return content;
}

/**
  <function name="convertPage"/>
 */
function convertPage(content, options) {

  // 3.1
  content = content.replace(new RegExp(
    '<link\\s+rel="stylesheet"\\s+type="text/css"\\s+href="([^"]*)Themes/[^/]+/Style.css">', 'gi'), 
    '<link rel="stylesheet" type="text/css" href="$1Styles/{CCS_Style}/Style.css">');

  // 3.2
  content = content.replace(new RegExp(
    '<body[^>]*>', 'gi'), 
    '<body>');

  // 3.3
  content = content.replace(new RegExp(
    'class="(Aqua|BlueNote|Capuccino|Caravan|Clear|Cobalt|Coffee|DeepWater|Default|EasyStreet|Facet|FoggyDay|Folio'
      + '|GiantSteps|Graphite|Gray|HappyPumpkin|InLine|Knockout|LightWalk|Mailbox|Multipads|Nappa|Noise|NoMarks'
      + '|Olive|Purple|Python|RockIt|Salad|Snow|Somatic|Square|StormyWeather|Sulfur)[^"]*"', 'gi'), 
    '');

  return content;
}

/**
  <function name="changePageFile"/>
 */
function changePageFile(args) {
  var file = args.file;
  var options = args.options;
  // process components
  var pathToParent = "";
  for (var i = file.subfolder; i > 0; i--) {
    pathToParent += "../";
  }

  var xml = new ActiveXObject("MSXML.DOMDocument");
  if (!xml.load(file.path)) {
    toReport('Unable to load page file ' + file.path);
    return false;
  }

  var htmlTemplateFileName = file.path.replace(/\.ccp$/, ".html");
  var content = loadFile(htmlTemplateFileName);
  var components = new Enumerator(xml.selectNodes("//(Grid|EditableGrid|Record)"));
  for (;!components.atEnd(); components.moveNext()) {
    with (components.item()) {
      if (null != getAttribute('wizardTheme')) {
        content = convertComponentTemplate(content, nodeName, getAttribute('name'), options);
      }
    }
  }
  content = convertPage(content, pathToParent);

  var page = xml.selectSingleNode('/Page');
  var style = document.getElementById('style').value;

  removeAttributes(xml.documentElement, 
    {wizardTheme : "", wizardThemeVersion: "", wizardThemeType : ""});

  page.setAttribute('wizardThemeVersion', '3.0');
  page.setAttribute('wizardTheme', ('Dynamic' == style) ? '{CCS_Style}' : style);

  var datePickerNodes = xml.selectNodes('//DatePicker');
  var datePickers = new Enumerator(datePickerNodes);
  for (;!datePickers.atEnd(); datePickers.moveNext()) {
    with (datePickers.item()) {
      setAttribute('wizardPicture', 'Styles/{CCS_Style}/Images/DatePicker.gif');
      var str = getAttribute('style');
      if (null != str) {
        str = str.replace(new RegExp("(.*)Themes/[^/]*/Style.css" , "gi"), "$1Styles/{CCS_Style}/Style.css");
        setAttribute('style', str);
      }
    }
  }

  toReport('Changing page file ' + file.path);
  saveFile(htmlTemplateFileName, content);
  xml.save(file.path);
}

/**
  <function name="convertComponentTemplate"/>
 */
function convertComponentTemplate(content, component, name, options) {
  var regExp = new RegExp("(<!--\\s+BEGIN\\s+" + component + "\\s+" 
    + name + "\\s+-->)([.\\w\\W\\s]*)(<!--\\s+END\\s+" + component + "\\s+" 
    + name + "\\s+-->)", "i");
  var html = regExp.exec(content);
  var newTemplate = html[2];
  switch (component)
  {
  case "Record":
    newTemplate = convertRecord(newTemplate, options);
    break;
  case "Grid":
    newTemplate = convertGrid(newTemplate, options);
    break;
  case "EditableGrid":
    newTemplate = convertEditableGrid(newTemplate, options);
    break;
  }
  return content.replace(regExp, html[1] + newTemplate + html[3]);
}

/**
  <function name="changeProjectFile"/>
 */
function changeProjectFile(filename) {
  var xml = new ActiveXObject("MSXML.DOMDocument");
  if (!xml.load(filename)) {
    toReport('Unable to load project file ' + filename);
    return false;
  }
  removeAttributes(xml.documentElement, {wizardTheme : "", wizardThemeType : ""});
  var site = xml.selectSingleNode('/Site');
  var style = document.getElementById('style').value;
  if ('Dynamic' == style) {
    site.setAttribute('useDynamicStyles', 'True');
  } else {
    site.setAttribute('useDynamicStyles', 'False');
    site.setAttribute('defaultStyle', style);
  }
  toReport('Changing project file ' + filename);

  xml.save(filename);
}
