function ProgressBar() {
  this._progress = 0;
  this._maxProgress = 10;
  this._onChangeProgress = function () {};
  this._controller = new ProgressBarController(this);
}

ProgressBar.prototype = {

  setProgress : function (value) {
    this._progress = value;
    this._onChangeProgress();
  },

  getProgress : function () {
    return this._progress;
  },

  setMaxProgress : function (value) {
    this._maxProgress = value;

  },

  getMaxProgress : function () {
    return this._maxProgress;
  },

  getPercent : function () {
    return Math.ceil(this._progress * 100 / this._maxProgress);
  },

  getController : function () {
    return this._controller;
  }

};

function ProgressBarController(model) {
  this._model = model;
}

ProgressBarController.prototype = {

  reset : function (maxPoints) {
    with (this._model) {
      setMaxProgress(maxPoints);
      setProgress(0);
    }
  },

  inc : function () {
    with (this._model) {
      setProgress(getProgress() + 1);
    }
  }

};

function ProgressBarView(model, control) {
  this._model = model;
  this._control = control;

  var _this = this;
  this._model._onChangeProgress = function () {
    _this.update();
  };
}

ProgressBarView.prototype = {

  update : function () {
    this._control.style.width = this._model.getPercent() + "%";
  }

};
